OGRE: Ogre::Texture Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Texture Class Referenceabstract
Core » Resources

Abstract class representing a Texture resource. More...

`#include <OgreTexture.h>`

Inheritance diagram for Ogre::Texture:
[legend]

## Public Member Functions
| Texture (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
virtual | ~Texture ()
void | _loadImages (const ConstImagePtrList &images)
| Internal method to load the texture from a set of images.
virtual void | _setD3D11Surface (void *surface)
| D3D11 only: set a shared surface to use for this texture before loading.
void | convertToImage (Image &destImage, bool includeMipMaps=false)
| Populate an Image with the contents of this texture.
virtual void | copyToTexture (TexturePtr &target)
| Copies (and maybe scales to fit) the contents of this texture to another texture.
void | createInternalResources (void)
| Creates the internal texture resources for this texture.
virtual void | createShaderAccessPoint (uint bindPoint, TextureAccess access=TA_READ_WRITE, int mipmapLevel=0, int textureArrayIndex=0, PixelFormat format=PF_UNKNOWN)
| Enable read and/or write privileges to the texture from shaders.
virtual const HardwarePixelBufferPtr & | getBuffer (size_t face=0, size_t mipmap=0)
| Return hardware pixel buffer for a surface.
uint | getCustomAttribute (const String &name)
| simplified API for bindings
virtual void | getCustomAttribute (const String &name, void *pData)
| Retrieve a platform or API-specific piece of information from this texture.
uint32 | getDepth (void) const
| Returns the depth of the texture (only applicable for 3D textures).
ushort | getDesiredFloatBitDepth (void) const
| gets desired bit depth for float pixel format textures.
PixelFormat | getDesiredFormat (void) const
| Returns the desired pixel format for the texture surface.
ushort | getDesiredIntegerBitDepth (void) const
| gets desired bit depth for integer pixel format textures.
PixelFormat | getFormat () const
| Returns the pixel format for the texture surface.
uint | getFSAA () const
| Get the level of multisample AA to be used if this texture is a rendertarget.
const String & | getFSAAHint () const
| Get the multisample AA hint if this texture is a rendertarget.
float | getGamma (void) const
| Returns the gamma adjustment factor applied to this texture on loading.
uint32 | getHeight (void) const
| Returns the height of the texture.
bool | getMipmapsHardwareGenerated (void) const
| Are mipmaps hardware generated?
uint32 | getNumFaces () const
| Return the number of faces this texture has.
uint32 | getNumLayers () const
| Returns 6 for cubemaps and the the depth otherwise.
uint32 | getNumMipmaps (void) const
| Gets the number of mipmaps to be used for this texture.
RenderTarget * | getRenderTarget (size_t slice=0, size_t mipmap=0)
| Convenience method for unified cubemap and 2D array access.
uint32 | getSrcDepth (void) const
| Returns the original depth of the input texture (only applicable for 3D textures).
PixelFormat | getSrcFormat (void) const
| Returns the pixel format of the original input texture (may differ due to hardware requirements and pixel format conversion).
uint32 | getSrcHeight (void) const
| Returns the height of the original input texture (may differ due to hardware requirements).
uint32 | getSrcWidth (void) const
| Returns the width of the original input texture (may differ due to hardware requirements).
TextureType | getTextureType (void) const
| Gets the type of texture.
int | getUsage () const
| Returns the TextureUsage identifier for this Texture.
uint32 | getWidth (void) const
| Returns the width of the texture.
bool | hasAlpha (void) const
| Returns true if the texture has an alpha layer.
bool | isHardwareGammaEnabled () const
| Gets whether this texture will be set up so that on sampling it, hardware gamma correction is applied.
void | loadImage (const Image &img)
| Loads the data from an image.
void | loadRawData (DataStreamPtr &stream, ushort uWidth, ushort uHeight, PixelFormat eFormat)
| Loads the data from a raw stream.
void | setDepth (uint32 d)
| Set the depth of the texture (only applicable for 3D textures); can only do this before load();.
void | setDesiredBitDepths (ushort integerBits, ushort floatBits)
| Sets desired bit depth for integer and float pixel format.
void | setDesiredFloatBitDepth (ushort bits)
| Sets desired bit depth for float pixel format textures.
void | setDesiredIntegerBitDepth (ushort bits)
| Sets desired bit depth for integer pixel format textures.
void | setFormat (PixelFormat pf)
| Sets the desired pixel format for the texture surface; can only be set before load().
void | setFSAA (uint fsaa, const String &fsaaHint)
| Set the level of multisample AA to be used if this texture is a rendertarget.
void | setGamma (float g)
| Sets the gamma adjustment factor applied to this texture on loading the data.
void | setHardwareGammaEnabled (bool enabled)
| Sets whether this texture will be set up so that on sampling it, hardware gamma correction is applied.
void | setHeight (uint32 h)
| Set the height of the texture; can only do this before load();.
void | setLayerNames (const std::vector< String > &names)
| Set image names to be loaded as layers (3d & texture array) or cubemap faces.
void | setNumMipmaps (uint32 num)
| Sets the number of mipmaps to be used for this texture.
void | setTextureType (TextureType ttype)
| Sets the type of texture; can only be changed before load().
void | setTreatLuminanceAsAlpha (bool asAlpha)
void | setUsage (int u)
| Sets the TextureUsage identifier for this Texture; only useful before load().
void | setWidth (uint32 w)
| Set the width of the texture; can only do this before load();.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

Abstract class representing a Texture resource.

The actual concrete subclass which will exist for a texture is dependent on the rendering system in use (Direct3D, OpenGL etc). This class represents the commonalities, and is the one 'used' by programmers even though the real implementation could be different in reality. Texture objects are created through the 'create' method of the TextureManager concrete subclass.

## Constructor & Destructor Documentation

## ◆ Texture()

Ogre::Texture::Texture | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

## ◆ ~Texture()

virtual Ogre::Texture::~Texture | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ setTextureType()

void Ogre::Texture::setTextureType | ( | TextureType | ttype | ) |
| inline

Sets the type of texture; can only be changed before load().

## ◆ getTextureType()

TextureType Ogre::Texture::getTextureType | ( | void |  | ) | const
| inline

Gets the type of texture.

## ◆ _setD3D11Surface()

virtual void Ogre::Texture::_setD3D11Surface | ( | void * | surface | ) |
| inlinevirtual

D3D11 only: set a shared surface to use for this texture before loading.

Useful for WPF interop

## ◆ getNumMipmaps()

uint32 Ogre::Texture::getNumMipmaps | ( | void |  | ) | const
| inline

Gets the number of mipmaps to be used for this texture.

## ◆ setNumMipmaps()

void Ogre::Texture::setNumMipmaps | ( | uint32 | num | ) |
| inline

Sets the number of mipmaps to be used for this texture.

Note
  Must be set before calling any 'load' method.

References Ogre::TU_AUTOMIPMAP.

## ◆ getMipmapsHardwareGenerated()

bool Ogre::Texture::getMipmapsHardwareGenerated | ( | void |  | ) | const
| inline

Are mipmaps hardware generated?

Will only be accurate after texture load, or createInternalResources

## ◆ getGamma()

float Ogre::Texture::getGamma | ( | void |  | ) | const
| inline

Returns the gamma adjustment factor applied to this texture on loading.

## ◆ setGamma()

void Ogre::Texture::setGamma | ( | float | g | ) |
| inline

Sets the gamma adjustment factor applied to this texture on loading the data.

Note
  Must be called before any 'load' method. This gamma factor will be premultiplied in and may reduce the precision of your textures. You can use setHardwareGamma if supported to apply gamma on sampling the texture instead.

## ◆ setHardwareGammaEnabled()

void Ogre::Texture::setHardwareGammaEnabled | ( | bool | enabled | ) |
| inline

Sets whether this texture will be set up so that on sampling it, hardware gamma correction is applied.

24-bit textures are often saved in gamma colour space; this preserves precision in the 'darks'. However, if you're performing blending on the sampled colours, you really want to be doing it in linear space. One way is to apply a gamma correction value on loading (see setGamma), but this means you lose precision in those dark colours. An alternative is to get the hardware to do the gamma correction when reading the texture and converting it to a floating point value for the rest of the pipeline. This option allows you to do that; it's only supported in relatively recent hardware (others will ignore it) but can improve the quality of colour reproduction.

Note
  Must be called before any 'load' method since it may affect the construction of the underlying hardware resources. Also note this only useful on textures using 8-bit colour channels.

## ◆ isHardwareGammaEnabled()

bool Ogre::Texture::isHardwareGammaEnabled | ( |  | ) | const
| inline

Gets whether this texture will be set up so that on sampling it, hardware gamma correction is applied.

## ◆ setFSAA()

void Ogre::Texture::setFSAA | ( | uint | fsaa,
|  | const String & | fsaaHint )
| inline

Set the level of multisample AA to be used if this texture is a rendertarget.

Note
  This option will be ignored if TU_RENDERTARGET is not part of the usage options on this texture, or if the hardware does not support it.

Parameters

  fsaa | The number of samples
  fsaaHint | Any hinting text (see Root::createRenderWindow)

## ◆ getFSAA()

uint Ogre::Texture::getFSAA | ( |  | ) | const
| inline

Get the level of multisample AA to be used if this texture is a rendertarget.

## ◆ getFSAAHint()

const String & Ogre::Texture::getFSAAHint | ( |  | ) | const
| inline

Get the multisample AA hint if this texture is a rendertarget.

## ◆ getHeight()

uint32 Ogre::Texture::getHeight | ( | void |  | ) | const
| inline

Returns the height of the texture.

## ◆ getWidth()

uint32 Ogre::Texture::getWidth | ( | void |  | ) | const
| inline

Returns the width of the texture.

## ◆ getDepth()

uint32 Ogre::Texture::getDepth | ( | void |  | ) | const
| inline

Returns the depth of the texture (only applicable for 3D textures).

## ◆ getSrcHeight()

uint32 Ogre::Texture::getSrcHeight | ( | void |  | ) | const
| inline

Returns the height of the original input texture (may differ due to hardware requirements).

## ◆ getSrcWidth()

uint32 Ogre::Texture::getSrcWidth | ( | void |  | ) | const
| inline

Returns the width of the original input texture (may differ due to hardware requirements).

## ◆ getSrcDepth()

uint32 Ogre::Texture::getSrcDepth | ( | void |  | ) | const
| inline

Returns the original depth of the input texture (only applicable for 3D textures).

## ◆ setHeight()

void Ogre::Texture::setHeight | ( | uint32 | h | ) |
| inline

Set the height of the texture; can only do this before load();.

## ◆ setWidth()

void Ogre::Texture::setWidth | ( | uint32 | w | ) |
| inline

Set the width of the texture; can only do this before load();.

## ◆ setDepth()

void Ogre::Texture::setDepth | ( | uint32 | d | ) |
| inline

Set the depth of the texture (only applicable for 3D textures); can only do this before load();.

## ◆ getUsage()

int Ogre::Texture::getUsage | ( |  | ) | const
| inline

Returns the TextureUsage identifier for this Texture.

## ◆ setUsage()

void Ogre::Texture::setUsage | ( | int | u | ) |
| inline

Sets the TextureUsage identifier for this Texture; only useful before load().

Parameters

  u | is a combination of TU_STATIC, TU_DYNAMIC, TU_WRITE_ONLY TU_AUTOMIPMAP and TU_RENDERTARGET (see TextureUsage enum). You are strongly advised to use HBU_GPU_ONLY wherever possible, if you need to update regularly, consider HBU_CPU_TO_GPU.

## ◆ createInternalResources()

void Ogre::Texture::createInternalResources | ( | void |  | ) |

Creates the internal texture resources for this texture.

This method creates the internal texture resources (pixel buffers, texture surfaces etc) required to begin using this texture. You do not need to call this method directly unless you are manually creating a texture, in which case something must call it, after having set the size and format of the texture (e.g. the ManualResourceLoader might be the best one to call it). If you are not defining a manual texture, or if you use one of the self-contained load...() methods, then it will be called for you.

## ◆ copyToTexture()

virtual void Ogre::Texture::copyToTexture | ( | TexturePtr & | target | ) |
| virtual

Copies (and maybe scales to fit) the contents of this texture to another texture.

## ◆ loadImage()

void Ogre::Texture::loadImage | ( | const Image & | img | ) |

Loads the data from an image.

Attention
  only call this from outside the load() routine of a Resource. Don't call it within (including ManualResourceLoader) - use _loadImages() instead. This method is designed to be external, performs locking and checks the load status before loading.

## ◆ loadRawData()

void Ogre::Texture::loadRawData | ( | DataStreamPtr & | stream,
|  | ushort | uWidth,
|  | ushort | uHeight,
|  | PixelFormat | eFormat )

Loads the data from a raw stream.

Attention
  only call this from outside the load() routine of a Resource. Don't call it within (including ManualResourceLoader) - use _loadImages() instead. This method is designed to be external, performs locking and checks the load status before loading.

Parameters

  stream | Data stream containing the raw pixel data
  uWidth | Width of the image
  uHeight | Height of the image
  eFormat | The format of the pixel data

## ◆ _loadImages()

void Ogre::Texture::_loadImages | ( | const ConstImagePtrList & | images | ) |

Internal method to load the texture from a set of images.

Attention
  Do NOT call this method unless you are inside the load() routine already, e.g. a ManualResourceLoader. It is not threadsafe and does not check or update resource loading status.

## ◆ getFormat()

PixelFormat Ogre::Texture::getFormat | ( |  | ) | const
| inline

Returns the pixel format for the texture surface.

## ◆ getDesiredFormat()

PixelFormat Ogre::Texture::getDesiredFormat | ( | void |  | ) | const
| inline

Returns the desired pixel format for the texture surface.

## ◆ getSrcFormat()

PixelFormat Ogre::Texture::getSrcFormat | ( | void |  | ) | const
| inline

Returns the pixel format of the original input texture (may differ due to hardware requirements and pixel format conversion).

## ◆ setFormat()

void Ogre::Texture::setFormat | ( | PixelFormat | pf | ) |

Sets the desired pixel format for the texture surface; can only be set before load().

## ◆ hasAlpha()

bool Ogre::Texture::hasAlpha | ( | void |  | ) | const

Returns true if the texture has an alpha layer.

## ◆ setDesiredIntegerBitDepth()

void Ogre::Texture::setDesiredIntegerBitDepth | ( | ushort | bits | ) |

Sets desired bit depth for integer pixel format textures.

Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.

## ◆ getDesiredIntegerBitDepth()

ushort Ogre::Texture::getDesiredIntegerBitDepth | ( | void |  | ) | const

gets desired bit depth for integer pixel format textures.

## ◆ setDesiredFloatBitDepth()

void Ogre::Texture::setDesiredFloatBitDepth | ( | ushort | bits | ) |

Sets desired bit depth for float pixel format textures.

Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.

## ◆ getDesiredFloatBitDepth()

ushort Ogre::Texture::getDesiredFloatBitDepth | ( | void |  | ) | const

gets desired bit depth for float pixel format textures.

## ◆ setDesiredBitDepths()

void Ogre::Texture::setDesiredBitDepths | ( | ushort | integerBits,
|  | ushort | floatBits )

Sets desired bit depth for integer and float pixel format.

## ◆ setTreatLuminanceAsAlpha()

void Ogre::Texture::setTreatLuminanceAsAlpha | ( | bool | asAlpha | ) |

Deprecated
  use setFormat(PF_A8)

## ◆ getNumFaces()

uint32 Ogre::Texture::getNumFaces | ( |  | ) | const
| inline

Return the number of faces this texture has.

This will be 6 for a cubemap texture and 1 for a 1D, 2D or 3D one.

References Ogre::TEX_TYPE_CUBE_MAP.

## ◆ getNumLayers()

uint32 Ogre::Texture::getNumLayers | ( |  | ) | const
| inline

Returns 6 for cubemaps and the the depth otherwise.

References Ogre::TEX_TYPE_CUBE_MAP.

## ◆ getRenderTarget()

RenderTarget * Ogre::Texture::getRenderTarget | ( | size_t | slice = 0,
|  | size_t | mipmap = 0 )

Convenience method for unified cubemap and 2D array access.

## ◆ getBuffer()

virtual const HardwarePixelBufferPtr & Ogre::Texture::getBuffer | ( | size_t | face = 0,
|  | size_t | mipmap = 0 )
| virtual

Return hardware pixel buffer for a surface.

This buffer can then be used to copy data from and to a particular level of the texture.

Parameters

  face | Face number, in case of a cubemap texture. Must be 0 for other types of textures. For cubemaps, this is one of +X (0), -X (1), +Y (2), -Y (3), +Z (4), -Z (5)
  mipmap | Mipmap level. This goes from 0 for the first, largest mipmap level to getNumMipmaps()-1 for the smallest.

Returns
  A shared pointer to a hardware pixel buffer.

Remarks
  The buffer is invalidated when the resource is unloaded or destroyed. Do not use it after the lifetime of the containing texture.

## ◆ convertToImage()

void Ogre::Texture::convertToImage | ( | Image & | destImage,
|  | bool | includeMipMaps = false )

Populate an Image with the contents of this texture.

Parameters

  destImage | The target image (contents will be overwritten)
  includeMipMaps | Whether to embed mipmaps in the image

## ◆ getCustomAttribute() [1/2]

virtual void Ogre::Texture::getCustomAttribute | ( | const String & | name,
|  | void * | pData )
| virtual

Retrieve a platform or API-specific piece of information from this texture.

This method of retrieving information should only be used if you know what you're doing.

Name | Description
--- | ---
GLID | The OpenGL texture object id

Parameters

  name | The name of the attribute to retrieve.
  pData | Pointer to memory matching the type of data you want to retrieve.

Referenced by getCustomAttribute().

## ◆ getCustomAttribute() [2/2]

uint Ogre::Texture::getCustomAttribute | ( | const String & | name | ) |
| inline

simplified API for bindings

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References getCustomAttribute().

## ◆ createShaderAccessPoint()

virtual void Ogre::Texture::createShaderAccessPoint | ( | uint | bindPoint,
|  | TextureAccess | access = TA_READ_WRITE,
|  | int | mipmapLevel = 0,
|  | int | textureArrayIndex = 0,
|  | PixelFormat | format = PF_UNKNOWN )
| inlinevirtual

Enable read and/or write privileges to the texture from shaders.

Parameters

  bindPoint | The buffer binding location for shader access. For OpenGL this must be unique and is not related to the texture binding point.
  access | The texture access privileges given to the shader.
  mipmapLevel | The texture mipmap level to use.
  textureArrayIndex | The index of the texture array to use. If texture is not a texture array, set to 0.
  format | Texture format to be read in by shader. For OpenGL this may be different than the bound texture format.

References Ogre::PF_UNKNOWN, and Ogre::TA_READ_WRITE.

## ◆ setLayerNames()

void Ogre::Texture::setLayerNames | ( | const std::vector< String > & | names | ) |
| inline

Set image names to be loaded as layers (3d & texture array) or cubemap faces.

The documentation for this class was generated from the following file:

- OgreTexture.h